package com.yixin.ms.server;

import cn.hutool.core.lang.UUID;
import cn.hutool.core.math.MathUtil;
import cn.hutool.core.util.DesensitizedUtil;
import cn.hutool.core.util.IdcardUtil;
import cn.hutool.core.util.RandomUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.yixin.ms.boot.restful.RestResult;
import com.yixin.ms.boot.restful.ServiceException;
import com.yixin.ms.boot.uitls.Preconditions;
import com.yixin.ms.boot.uitls.RedisUtil;
import com.yixin.ms.boot.uitls.SMSOrIdCardUtils;
import com.yixin.ms.crypto.util.Sm4Util;
import com.yixin.ms.model.dto.ShortTermDTO;
import com.yixin.ms.model.dto.ThirdPlatformDTO;
import com.yixin.ms.model.dto.ThirdPlatformRespDto;
import com.yixin.ms.model.dto.ThirdPlatformSm4DTO;
import com.yixin.ms.model.dto.ThirdPlatformSm4RespDto;
import com.yixin.ms.model.enums.*;
import com.yixin.ms.model.vo.ChooseVO;
import com.yixin.ms.model.vo.HealtCodeNucleinVO;
import com.yixin.ms.model.vo.HealtCodeTypeVO;
import com.yixin.ms.model.vo.HealtCodeUserVO;
import com.yixin.ms.model.vo.MultipleChooseItemVO;
import com.yixin.ms.model.vo.MultipleChooseVO;
import com.yixin.ms.server.dto.QuTongIdentityAuthDto;
import com.yixin.ms.server.dto.ScenicVerifyDTO;
import com.yixin.ms.server.vo.PlaceInfoVO;
import com.yixin.ms.server.vo.QuTongIdentityVO;
import com.yixin.ms.server.vo.QuTongIdentityVO.RespCodeEnum;
import com.yixin.ms.server.vo.ScenicVerifyVO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @description:
 * @ClassName HealthOpenReturnServer
 * @Author WXG
 * @Date 2022/10/20 17:34
 */
@Slf4j
@Service
public class HealthOpenReturnServer {
    public void healthOpenReturn(HealtCodeUserVO userVO, PlaceInfoVO placeInfoVO, ShortTermDTO shortTermDTO) {
        userVO.setShowPageType("scenic");
        //开门声音提示
        String openMsg = placeInfoVO.getOpenMsg();
        String openVoiceMsg = "";
        userVO.setIsOpen(placeInfoVO.getIsOpen());
        /*******************************以下为通行结果逻辑*******************************/
        //通行结果转换
        String subLine = openMsg;
        if (userVO.getIsOpen() != null
                && userVO.getIsOpen().intValue() == HealthOpenEnum.NO_THOROUGHFARE.getCode().intValue()) {//禁止通行
            //是否开启警报
            userVO.setVaccineIconUrl("https://tx.hz-hanghui.com:8088/yx-fyzd/file/icon/warning.png");
            userVO.setVaccineNumColor("#ed593b");
            openMsg = Preconditions.isNotBlank(openMsg) ? openMsg : "禁止通行";
            subLine = Preconditions.isNotBlank(subLine) ? subLine : "禁止通行";

            userVO.setOpenTimes(0);
            userVO.setAMainIcon(Preconditions.isNotBlank(userVO.getAMainIcon()) ? userVO.getAMainIcon() : ThirdPlatformPassIconEnum.AFORBID.getUrl());
            userVO.setAMainLine(Preconditions.isNotBlank(userVO.getAMainLine()) ? userVO.getAMainLine() : openMsg);
        } else {//请通行
            userVO.setAMainIcon(Preconditions.isNotBlank(userVO.getAMainIcon()) ? userVO.getAMainIcon() : ThirdPlatformPassIconEnum.APASS.getUrl());
            userVO.setAMainLine(Preconditions.isNotBlank(userVO.getAMainLine()) ? userVO.getAMainLine() : openMsg);
        }

        //设置开门信号提示信息
        openVoiceMsg = openMsg;
        userVO.setOpenMsg(Preconditions.isNotBlank(subLine) ? subLine : openMsg);
        userVO.setOpenVoiceMsg(openVoiceMsg);
        //设置通行结果数据
        HealtCodeTypeVO codeTypeVO = userVO.getData().stream().findFirst().get();
        if (Preconditions.isNotBlank(codeTypeVO)) {
            codeTypeVO.setContent(subLine);
            userVO.setData(Arrays.asList(codeTypeVO));
        }
    }

}
